include:
  - project: 'repos/releng/kokkuri'
    file: 'includes/images.yaml'

stages:
  - test
  - conformance
  - publish

default:
  tags:
    - kubernetes

workflow:
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    - if: $CI_COMMIT_TAG && $CI_COMMIT_REF_PROTECTED

lint:
  stage: test
  extends: .kokkuri:build-and-run-image
  variables:
    BUILD_VARIANT: lint

test:
  stage: test
  extends: .kokkuri:build-and-run-image
  variables:
    BUILD_VARIANT: test

smoketest-image:
  stage: test
  extends: .kokkuri:build-and-run-image
  variables:
    BUILD_VARIANT: smoketest

build-image:
  stage: test
  extends: .kokkuri:build-and-publish-image
  variables:
    BUILD_VARIANT: image
    PUBLISH_IMAGE_TAG: job-$CI_JOB_ID
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'

build-conformance-tester:
  stage: test
  extends: .kokkuri:build-and-publish-image
  variables:
    BUILD_VARIANT: conformance
    PUBLISH_IMAGE_TAG: job-$CI_JOB_ID
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'

ensure-oci-conformance:
  stage: conformance
  services:
    - name: $BUILD_IMAGE_IMAGE_REF
      alias: reggie
      variables:
        REGGIE_DATA_DIR: ${CI_BUILDS_DIR}/reggie-data
  image: $BUILD_CONFORMANCE_TESTER_IMAGE_REF
  script:
    - /conformance.test
  variables:
    OCI_ROOT_URL: 'http://reggie:5000'
    OCI_NAMESPACE: 'myorg/myrepo'
    OCI_CROSSMOUNT_NAMESPACE: 'myorg/other'
    OCI_TAG_NAME: 'mytag'
    OCI_TEST_PULL: '1'
    OCI_TEST_PUSH: '1'
    OCI_TEST_CONTENT_DISCOVERY: '1'
    OCI_TEST_CONTENT_MANAGEMENT: '1'
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'

build-and-publish-image:
  stage: publish
  extends: .kokkuri:build-and-publish-image
  variables:
    BUILD_VARIANT: image
  tags:
    - trusted
  rules:
    - if: $CI_COMMIT_TAG && $CI_COMMIT_REF_PROTECTED

lint-helm-chart:
  stage: test
  extends: .kokkuri:build-and-run-image
  variables:
    BUILD_VARIANT: helm-lint
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

package-and-publish-helm-chart:
  stage: publish
  extends: .kokkuri:build-image
  variables:
    BUILD_VARIANT: helm-package
    BUILDCTL_BUILD_FLAGS: '--output type=local,dest=helm/charts'
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  artifacts:
    paths:
      - helm/charts/reggie.tgz
